import es, cmdlib, playerlib
import os

dm = es.import_addon('dm')

spawn_path = dm.addondir + '/dm/addons/spawnpoints/maps/'
spawn_locations = []

def load():
    #es.load('dm/addons/spawnpoints/ess')
    #cmdlib.registerServerCommand('dm_createspawnpoint', 'dm/addons/spawnpoints/ess/cmd_createspawn', 'DM-Spawnpoints internal command')
    
    cmdlib.registerSayCommand('!spawnpoint', cmd_add, 'Create a spawnpoint at your current location')
    
    if not os.path.isdir(spawn_path):
        os.makedirs(spawn_path)
    
    loadLocations()
    
def unload():
    #cmdlib.unregisterServerCommand('dm_createspawnpoint')
    cmdlib.unregisterSayCommand('!spawnpoint')
    #es.unload('dm/addons/spawnpoints/ess')
    
def cmd_add(userid, args):

    if dm.isAuthed(userid):
        location = reduce(lambda x,y: '%s,%s'%(x,y), es.getplayerlocation(userid))
        angle = reduce(lambda x,y: '%s,%s'%(x,y), playerlib.getPlayer(userid).getViewAngle())
        
        spawn_locations.append([location, angle])
        
        cmap = str(es.ServerVar('eventscripts_currentmap'))
        filename = spawn_path + cmap + '.txt'
        if not os.path.isfile(filename):
            open(filename, 'w').close()
        
        x = open(filename, 'a')
        x.write('%s %s\n'%(location, angle))
        x.close()
        
        dm.tell(userid, 'Created Spawn Point [%s] [%s]'%(location,angle))
    else:
        dm.tell(userid, 'You don\'t have access to that command!')
    
def es_map_start(ev):
    loadLocations()
    
def loadLocations():
    global spawn_locations
    cmap = str(es.ServerVar('eventscripts_currentmap'))
    spawn_locations = []
    
    if not cmap: return
    
    filename = spawn_path + cmap + '.spawn'
    if os.path.isfile(filename):
        spawnfile = open(filename, 'r')
        lines = spawnfile.readlines()
        spawnfile.close()
        for line in lines:
            line = line.strip()
            if line:
                spawn_locations.append(line.split(' '))
    
    
def getSpawnIndexs():
    entlist = lambda x: list(es.createentitylist(x))
    return entlist('info_player_terrorist') + entlist('info_player_counterterrorist')
    
    
def round_start(ev):
    if spawn_locations:
        userid = es.getuserid()
        if userid:
            for index in getSpawnIndexs():
                es.server.queuecmd('es_xremove %s'%index)
                
            for details in spawn_locations:
                loc,ang = details
                es.server.queuecmd(execstr%(userid, 'info_player_terrorist', loc, ang))
                es.server.queuecmd(execstr%(userid, 'info_player_counterterrorist', loc, ang))
                
execstr = 'es_xgive %s %s;es_setindexprop server_var(eventscripts_lastgive) CBaseEntity.m_vecOrigin %s;es_setindexprop server_var(eventscripts_lastgive) CBaseEntity.m_angRotation %s'
            
        